Subject: Re: bug#54190: 29.0.50; [PATCH] Incorrect/missing documentation for some Eshell "$" syntaxes

From: Jim Porter <[email-masked]>
Date: Mon, 28 Feb 2022 00:16:21 -0800

On 2/27/2022 10:11 PM, Jim Porter wrote:
> Hmm, that's unfortunate. It seems that the "$<FOO>" syntax in Eshell 
> broke sometime between 27.2 and 28. I'm bisecting to figure out where 
> that happened, but figured I'd mention it now so there's no confusion if 
> someone tries it out now on 28/29. Fix forthcoming (hopefully).

Ok, the breaking commit is b03f74e0f2a578b1580e8b1c368665850ee7f808 
("Don't quote lambdas in several places"). Reverting the change in that 
commit in lisp/eshell/esh-var.el fixes things, although I'm not sure why 
yet. I believe that code gets evaluated by `eshell-do-eval', which 
evaluates things in a very particular way in order to support deferring 
evaluation at various points. Once I'm sure I understand why this is 
breaking, I'll post a patch to fix the bustage.